Index: /branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/delta_aux_3view_simu.cfg
===================================================================
--- /branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/delta_aux_3view_simu.cfg	(revision 1373)
+++ /branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/delta_aux_3view_simu.cfg	(revision 1373)
@@ -0,0 +1,154 @@
+#======== Legend for comments ===================== 
+# (m) specification per layer/dimension/layerset possible
+# (c) cyclic repetition of values, if not given for all layers/dimensions/layersets. (e.g. 5 layers and 1 2 3 -> 1 2 3 1 2  )
+
+
+NumberOfLayers         : 6       
+
+#======== VPS ============================
+ScalabilityMask        : 10        # Scalability Mask             ( Scalability Mask: 2: Multiview, 8: Auxiliary, 10: Multiview + Auxiliary )
+DimensionIdLen         : 4 4       #  Number of bits to store Ids,  per scalability dimension, (m)
+ViewOrderIndex         : 0 0 1 1 2 2    #  # ViewOrderIndex, per layer (m)
+AuxId                  : 0 2 0 2 0 2 # Auxiliary Id, per layer (m), ( 0: none, 1: Alpha, 2: Depth )
+LayerIdInNuh           : 0 1 2 3 4 5   #  Layer Id in NAL unit header, (0: no explicit signalling, otherwise per layer ) (m)
+
+#======== VPS/ Layer sets ================
+VpsNumLayerSets        : 1           #  Number of layer sets    
+LayerIdsInSet_0        : 0           #  Indices in VPS of layers in layer set 0  (here: LS 0)
+LayerIdsInSet_1        :             #  Indices in VPS of layers in layer set 1  (here: LS 1)
+LayerIdsInSet_2        :             #  Indices in VPS of layers in layer set 1  (here: LS 1)
+LayerIdsInSet_3        :             #  Indices in VPS of layers in layer set 1  (here: LS 1)
+
+NumAddLayerSets        : 5                             #  Additional layer sets for independent decodable non-base layer
+HighestLayerIdxPlus1_0 : -1 1 0 0 0 0                  # Highest layer idx plus 1 for the 0-th additional layer set, per independent layer (m) (first value will be ignored) (here: LS 1)
+HighestLayerIdxPlus1_1 : -1 0 1 0 0 0                  # Highest layer idx plus 1 for the 1-th additional layer set, per independent layer (m) (first value will be ignored) (here: LS 2)
+HighestLayerIdxPlus1_2 : -1 0 0 1 0 0                  # Highest layer idx plus 1 for the 1-th additional layer set, per independent layer (m) (first value will be ignored) (here: LS 3)
+HighestLayerIdxPlus1_3 : -1 0 0 0 1 0                  # Highest layer idx plus 1 for the 1-th additional layer set, per independent layer (m) (first value will be ignored) (here: LS 4)
+HighestLayerIdxPlus1_4 : -1 0 0 0 0 1                  # Highest layer idx plus 1 for the 1-th additional layer set, per independent layer (m) (first value will be ignored) (here: LS 5)
+
+#======== VPS / Output layer sets ================
+OutputLayerSetIdx           :               #  Indices of layer sets used to derive additional output layer sets
+
+# TREE 0 (LS Idx (1))
+LayerIdsInAddOutputLayerSet_0 :         #  Indices in VPS of output layers in additional output layer set 0   (here: OLS 7)
+# TREE 1 (LS Idx (2))            
+LayerIdsInAddOutputLayerSet_1 :         #  Indices in VPS of output layers in additional output layer set 1   (here: OLS 8)
+# TREE 2 (LS Idx (4))            
+LayerIdsInAddOutputLayerSet_2 :         #  Indices in VPS of output layers in additional output layer set 2   (here: OLS 9)
+# TREE 3 (LS Idx (5))            
+LayerIdsInAddOutputLayerSet_3 :         #  Indices in VPS of output layers in additional output layer set 3   (here: OLS 10)
+# TREE 4 (LS Idx (6))            
+LayerIdsInAddOutputLayerSet_4 :         #  Indices in VPS of output layers in additional output layer set 4   (here: OLS 11)
+
+LayerIdsInAddOutputLayerSet_5 :         #  Indices in VPS of output layers in additional output layer set 4   (here: OLS 12)
+LayerIdsInAddOutputLayerSet_6 :         #  Indices in VPS of output layers in additional output layer set 4   (here: OLS 13)
+LayerIdsInAddOutputLayerSet_7 :         #  Indices in VPS of output layers in additional output layer set 4   (here: OLS 14)
+
+
+#======== VPS / PTLI ================
+
+Profile                       : main main main  # Profile indication in VpsProfileTierLevel, per VpsProfileTierLevel syntax structure  (m) 
+Level                         : none none none  # Level   indication in VpsProfileTierLevel, per VpsProfileTierLevel syntax structure  (m) 
+Tier                          : main main main  # Tier    indication in VpsProfileTierLevel, per VpsProfileTierLevel syntax structure  (m) 
+InblFlag                      : 0    0    1     # Inbl    indication in VpsProfileTierLevel, per VpsProfileTierLevel syntax structure  (m) 
+
+# For OLS corresponding to layer set
+ProfileTierLevelIdx_0         : 1                          # VpsProfileTierLevel indices of layers in output layer set 0 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_1         : 2                          # VpsProfileTierLevel indices of layers in output layer set 0 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_2         : 2                          # VpsProfileTierLevel indices of layers in output layer set 2 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_3         : 2                          # VpsProfileTierLevel indices of layers in output layer set 3 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_4         : 2                          # VpsProfileTierLevel indices of layers in output layer set 4 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_5         : 2                          # VpsProfileTierLevel indices of layers in output layer set 5 (m) (should be -1, when layer is not necessary)
+
+
+#======== VPS / Dependencies ================
+DirectRefLayers_1      :         #  Indices in VPS of direct reference layers 
+DirectRefLayers_2      :         #  Indices in VPS of direct reference layers 
+DirectRefLayers_3      :         #  Indices in VPS of direct reference layers 
+DirectRefLayers_4      :         #  Indices in VPS of direct reference layers 
+DirectRefLayers_5      :         #  Indices in VPS of direct reference layers 
+
+DependencyTypes_1      :         #  Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_2      :         #  Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_3      :         #  Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_4      :         #  Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_5      :         #  Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+
+
+#======== Coding Structure =============
+
+#                           QPfactor      betaOffsetDiv2   #ref_pics_active  reference pictures     deltaRPS     reference idcs          ilPredLayerIdc       refLayerPicPosIl_L1
+#         Type  POC QPoffset     tcOffsetDiv2      temporal_id      #ref_pics                 predict     #ref_idcs        #ActiveRefLayerPics     refLayerPicPosIl_L0   
+Frame1:     B    8     1     0.442    0        0        0        4      4     -8 -10 -12 -16     0      0
+Frame2:     B    4     2     0.3536   0        0        0        2      3     -4 -6  4           1      4    5     1 1 0 0 1       0
+Frame3:     B    2     3     0.3536   0        0        0        2      4     -2 -4  2 6         1      2    4     1 1 1 1         0
+Frame4:     B    1     4     0.68     0        0        0        2      4     -1  1  3 7         1      1    5     1 0 1 1 1       0
+Frame5:     B    3     4     0.68     0        0        0        2      4     -1 -3  1 5         1     -2    5     1 1 1 1 0       0
+Frame6:     B    6     3     0.3536   0        0        0        2      4     -2 -4 -6 2         1     -3    5     1 1 1 1 0       0
+Frame7:     B    5     4     0.68     0        0        0        2      4     -1 -5  1 3         1      1    5     1 0 1 1 1       0
+Frame8:     B    7     4     0.68     0        0        0        2      4     -1 -3 -7 1         1     -2    5     1 1 1 1 0       0
+    
+FrameI_l1:  I    0     0     0.442    0        0        0        0      0                        0                                 0             
+Frame1_l1:  B    8     1     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 0             
+Frame2_l1:  B    4     2     0.3536   0        0        0        2      3     -4 -6  4           1      4    5     1 1 0 0 1       0             
+Frame3_l1:  B    2     3     0.3536   0        0        0        2      4     -2 -4  2 6         1      2    4     1 1 1 1         0             
+Frame4_l1:  B    1     4     0.68     0        0        0        2      4     -1  1  3 7         1      1    5     1 0 1 1 1       0             
+Frame5_l1:  B    3     4     0.68     0        0        0        2      4     -1 -3  1 5         1     -2    5     1 1 1 1 0       0             
+Frame6_l1:  B    6     3     0.3536   0        0        0        2      4     -2 -4 -6 2         1     -3    5     1 1 1 1 0       0             
+Frame7_l1:  B    5     4     0.68     0        0        0        2      4     -1 -5  1 3         1      1    5     1 0 1 1 1       0             
+Frame8_l1:  B    7     4     0.68     0        0        0        2      4     -1 -3 -7 1         1     -2    5     1 1 1 1 0       0             
+
+FrameI_l2:  I    0     3     0.442    0        0        0        1      0                        0                                 0            
+Frame1_l2:  B    8     4     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 0            
+Frame2_l2:  B    4     5     0.3536   0        0        0        3      3     -4 -6  4           1     4     5     1 1 0 0 1       0            
+Frame3_l2:  B    2     6     0.3536   0        0        0        3      4     -2 -4  2 6         1     2     4     1 1 1 1         0            
+Frame4_l2:  B    1     7     0.68     0        0        0        3      4     -1  1  3 7         1     1     5     1 0 1 1 1       0            
+Frame5_l2:  B    3     7     0.68     0        0        0        3      4     -1 -3  1 5         1    -2     5     1 1 1 1 0       0            
+Frame6_l2:  B    6     6     0.3536   0        0        0        3      4     -2 -4 -6 2         1    -3     5     1 1 1 1 0       0            
+Frame7_l2:  B    5     7     0.68     0        0        0        3      4     -1 -5  1 3         1     1     5     1 0 1 1 1       0            
+Frame8_l2:  B    7     7     0.68     0        0        0        3      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0       0            
+
+FrameI_l3:  I    0     3     0.442    0        0        0        1      0                        0                                 0            
+Frame1_l3:  B    8     4     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 0            
+Frame2_l3:  B    4     5     0.3536   0        0        0        3      3     -4 -6  4           1     4     5     1 1 0 0 1       0            
+Frame3_l3:  B    2     6     0.3536   0        0        0        3      4     -2 -4  2 6         1     2     4     1 1 1 1         0            
+Frame4_l3:  B    1     7     0.68     0        0        0        3      4     -1  1  3 7         1     1     5     1 0 1 1 1       0            
+Frame5_l3:  B    3     7     0.68     0        0        0        3      4     -1 -3  1 5         1    -2     5     1 1 1 1 0       0            
+Frame6_l3:  B    6     6     0.3536   0        0        0        3      4     -2 -4 -6 2         1    -3     5     1 1 1 1 0       0            
+Frame7_l3:  B    5     7     0.68     0        0        0        3      4     -1 -5  1 3         1     1     5     1 0 1 1 1       0            
+Frame8_l3:  B    7     7     0.68     0        0        0        3      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0       0            
+
+FrameI_l4:  I    0     3     0.442    0        0        0        1      0                        0                                 0            
+Frame1_l4:  B    8     4     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 0            
+Frame2_l4:  B    4     5     0.3536   0        0        0        3      3     -4 -6  4           1     4     5     1 1 0 0 1       0            
+Frame3_l4:  B    2     6     0.3536   0        0        0        3      4     -2 -4  2 6         1     2     4     1 1 1 1         0            
+Frame4_l4:  B    1     7     0.68     0        0        0        3      4     -1  1  3 7         1     1     5     1 0 1 1 1       0            
+Frame5_l4:  B    3     7     0.68     0        0        0        3      4     -1 -3  1 5         1    -2     5     1 1 1 1 0       0            
+Frame6_l4:  B    6     6     0.3536   0        0        0        3      4     -2 -4 -6 2         1    -3     5     1 1 1 1 0       0            
+Frame7_l4:  B    5     7     0.68     0        0        0        3      4     -1 -5  1 3         1     1     5     1 0 1 1 1       0            
+Frame8_l4:  B    7     7     0.68     0        0        0        3      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0       0            
+
+FrameI_l5:  I    0     3     0.442    0        0        0        1      0                        0                                 0            
+Frame1_l5:  B    8     4     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 0            
+Frame2_l5:  B    4     5     0.3536   0        0        0        3      3     -4 -6  4           1     4     5     1 1 0 0 1       0            
+Frame3_l5:  B    2     6     0.3536   0        0        0        3      4     -2 -4  2 6         1     2     4     1 1 1 1         0            
+Frame4_l5:  B    1     7     0.68     0        0        0        3      4     -1  1  3 7         1     1     5     1 0 1 1 1       0            
+Frame5_l5:  B    3     7     0.68     0        0        0        3      4     -1 -3  1 5         1    -2     5     1 1 1 1 0       0            
+Frame6_l5:  B    6     6     0.3536   0        0        0        3      4     -2 -4 -6 2         1    -3     5     1 1 1 1 0       0            
+Frame7_l5:  B    5     7     0.68     0        0        0        3      4     -1 -5  1 3         1     1     5     1 0 1 1 1       0            
+Frame8_l5:  B    7     7     0.68     0        0        0        3      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0       0            
+
+
+LoopFilterDisable             : 0 1         # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
+SAO                           : 1 0         # Sample adaptive offset  (0: OFF, 1: ON) (mc)
+
+
+#========== view synthesis optimization (VSO) ==========
+VSO                       : 1                          # use of view synthesis optimization for depth coding
+VSOConfig                 : [cx0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) B(oo2) I(s0.25 s0.5 s0.75 s1.25 s1.5 s1.75)][cx2 B(cc1) I(s1.25 s1.5 s1.75)] # VSO configuration string
+#VSOConfig                 : [ox0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) B(oo2) I(s0.25 s0.5 s0.75 s1.25 s1.5 s1.75)][ox2 B(cc1) I(s1.25 s1.5 s1.75)] # VSO configuration string for FCO = 1
+WVSO                      : 1                                    # use of WVSO (Depth distortion metric with a weighted depth fidelity term) 
+VSOWeight                 : 10                                   # weight of VSO ( in SAD case, cf. squared in SSE case )
+VSDWeight                 : 1                                    # weight of VSD ( in SAD case, cf. squared in SSE case )
+DWeight                   : 1                                    # weight of depth distortion itself ( in SAD case, cf. squared in SSE case )
+UseEstimatedVSD           : 1                                    # Model based VSD estimation instead of rendering based for some encoder decisions      
Index: /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Balloons.cfg
===================================================================
--- /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Balloons.cfg	(revision 1372)
+++ /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Balloons.cfg	(revision 1373)
@@ -5,4 +5,4 @@
 FrameRate                 : 30                                     # frame rate in frames per second
 FramesToBeEncoded         : 300                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 3 1 5                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 3 1 5                                  # camera numbers of coded views (in coding order)
 
Index: /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_GhostTownFly.cfg
===================================================================
--- /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_GhostTownFly.cfg	(revision 1372)
+++ /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_GhostTownFly.cfg	(revision 1373)
@@ -5,4 +5,4 @@
 FrameRate                 : 25                                     # frame rate in frames per second
 FramesToBeEncoded         : 250                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 5 9 1                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 5 9 1                                  # camera numbers of coded views (in coding order)
 
Index: /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Kendo.cfg
===================================================================
--- /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Kendo.cfg	(revision 1372)
+++ /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Kendo.cfg	(revision 1373)
@@ -5,4 +5,4 @@
 FrameRate                 : 30                                     # frame rate in frames per second
 FramesToBeEncoded         : 300                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 3 1 5                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 3 1 5                                  # camera numbers of coded views (in coding order)
 
Index: /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Newspaper.cfg
===================================================================
--- /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Newspaper.cfg	(revision 1372)
+++ /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Newspaper.cfg	(revision 1373)
@@ -5,4 +5,4 @@
 FrameRate                 : 30                                     # frame rate in frames per second
 FramesToBeEncoded         : 300                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 4 2 6                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 4 2 6                                  # camera numbers of coded views (in coding order)
 
Index: /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_PoznanHall2.cfg
===================================================================
--- /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_PoznanHall2.cfg	(revision 1372)
+++ /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_PoznanHall2.cfg	(revision 1373)
@@ -5,4 +5,4 @@
 FrameRate                 : 25                                     # frame rate in frames per second
 FramesToBeEncoded         : 200                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 6 7 5                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 6 7 5                                  # camera numbers of coded views (in coding order)
 
Index: /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_PoznanStreet.cfg
===================================================================
--- /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_PoznanStreet.cfg	(revision 1372)
+++ /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_PoznanStreet.cfg	(revision 1373)
@@ -5,4 +5,4 @@
 FrameRate                 : 25                                     # frame rate in frames per second
 FramesToBeEncoded         : 250                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 4 5 3                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 4 5 3                                  # camera numbers of coded views (in coding order)
 
Index: /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Shark.cfg
===================================================================
--- /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Shark.cfg	(revision 1372)
+++ /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_Shark.cfg	(revision 1373)
@@ -5,4 +5,4 @@
 FrameRate                 : 30                                     # frame rate in frames per second
 FramesToBeEncoded         : 300                                    # number of frames to be coded
-#BaseViewCameraNumbers    : 5 9 1                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers    : 5 9 1                                  # camera numbers of coded views (in coding order)
 
Index: /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_UndoDancer.cfg
===================================================================
--- /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_UndoDancer.cfg	(revision 1372)
+++ /branches/HTM-15.2-dev/cfg/MV-HEVC/seqCfg_UndoDancer.cfg	(revision 1373)
@@ -5,4 +5,4 @@
 FrameRate                 : 25                                     # frame rate in frames per second
 FramesToBeEncoded         : 250                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 5 1 9                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 5 1 9                                  # camera numbers of coded views (in coding order)
 
Index: /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 1373)
@@ -90,5 +90,5 @@
   ("OutputColourSpaceConvert",  outputColourSpaceConvert,              string(""), "Colour space conversion to apply to input 444 video. Permitted values are (empty string=UNCHANGED) " + getListOfColourSpaceConverts(false))
 #if NH_MV
-  ("TargetOptLayerSetIdx,x",    m_targetOptLayerSetIdx,                -1,         "Target output layer set index. (default: -1, determine automatically to be equal to highest layer set index") // Should actually equal to 0 as default. However, this would cause only the base layer to be decoded.  
+  ("TargetOptLayerSetIdx,x", m_targetOptLayerSetInd, std::vector<Int>(1,-1), "Target output layer set index. (default: -1, determine automatically to be equal to highest layer set index") // Should actually equal to 0 as default. However, this would cause only the base layer to be decoded.  
 #endif
   ("MaxTemporalLayer,t",        m_iMaxTemporalLayer,                   -1,         "Maximum Temporal Layer to be decoded. -1 to decode all layers")
Index: /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecCfg.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecCfg.h	(revision 1373)
@@ -81,5 +81,7 @@
   std::vector<TChar*> m_pchReconFiles;                ///< array of output reconstruction file name create from output reconstruction file name
 
-  Int           m_targetOptLayerSetIdx;               ///< target output layer set index
+  std::vector<Int> m_targetOptLayerSetInd;            ///< target output layer set indices (multiple decoding when more than one element, e.g. for additional layer sets)
+  Int           m_targetOptLayerSetIdx;               ///< current target output layer set index
+
   Int           m_targetDecLayerSetIdx;
   Int           m_baseLayerOutputFlag;
@@ -138,4 +140,7 @@
 
   Bool  parseCfg        ( Int argc, TChar* argv[] );   ///< initialize option class from configuration
+#if NH_MV
+  Int   getNumDecodings ( ) { return (Int) m_targetOptLayerSetInd.size();  }; 
+#endif
 };
 
Index: /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1373)
@@ -152,8 +152,8 @@
  .
  */
-
 #if NH_MV
-Void TAppDecTop::decode()
-{
+Void TAppDecTop::decode( Int num )
+{
+  m_targetOptLayerSetIdx = m_targetOptLayerSetInd[ num ]; 
   // create & initialize internal classes
   xInitFileIO  ();
@@ -213,5 +213,5 @@
 
 #if !NH_MV
-Void TAppDecTop::decode()
+Void TAppDecTop::decode( )
 {
   Int                 poc;
@@ -1092,5 +1092,5 @@
     m_newVpsActivatedbyCurAu  = true; //TBD
     m_newVpsActivatedbyCurPic = true;
-#if NH_3D
+#if NH_3D_VSO
     m_dpb.setVPS( m_vps ); 
 #endif
@@ -1256,5 +1256,5 @@
   }
 
-  if ( m_printVpsInfo  && ( m_decProcCvsg == ANNEX_F ) )
+  if ( m_printVpsInfo  && ( m_decProcCvsg == ANNEX_F ) && ( m_targetOptLayerSetIdx == m_targetOptLayerSetInd[ 0 ] ) )
   {
     m_vps->printScalabilityId();
@@ -2003,5 +2003,5 @@
       // - After all slices of the current picture have been decoded, the decoding process for ending the decoding of a
       //   coded picture with nuh_layer_id greater than 0 specified in clause F.8.1.6 is invoked.
-      xF816decProcEndDecOfCodPicLIdGrtZero( );
+      xF816decProcEndDecOfCodPicLIdGrtZero( );      
     }
 
Index: /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecTop.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/App/TAppDecoder/TAppDecTop.h	(revision 1373)
@@ -137,9 +137,11 @@
   Void  create            (); ///< create internal members
   Void  destroy           (); ///< destroy internal members
-  Void  decode            (); ///< main decoding function
+  
 #if NH_MV
+  Void  decode            ( Int i ); ///< main decoding function
   UInt  getNumberOfChecksumErrorsDetected( ) const;
   UInt  getNumberOfChecksumErrorsDetected( Int decIdx ) const { return m_tDecTop[decIdx]->getNumberOfChecksumErrorsDetected(); }
 #else
+  Void  decode            ( ); ///< main decoding function
   UInt  getNumberOfChecksumErrorsDetected() const { return m_cTDecTop.getNumberOfChecksumErrorsDetected(); }
 #endif
Index: /branches/HTM-15.2-dev/source/App/TAppDecoder/decmain.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/App/TAppDecoder/decmain.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/App/TAppDecoder/decmain.cpp	(revision 1373)
@@ -51,6 +51,7 @@
 {
   Int returnCode = EXIT_SUCCESS;
+#if !NH_MV
   TAppDecTop  cTAppDecTop;
-
+#endif
   // print information
   fprintf( stdout, "\n" );
@@ -65,35 +66,61 @@
   fprintf( stdout, "\n" );
 
-  // create application decoder class
-  cTAppDecTop.create();
+#if NH_MV
+  Int numDecodings = 1; 
+  Int curDecoding  = 0; 
+  Double dResult = 0; 
+  do {
+    TAppDecTop  cTAppDecTop;
+#endif
+    // create application decoder class
+    cTAppDecTop.create();
 
-  // parse configuration
-  if(!cTAppDecTop.parseCfg( argc, argv ))
-  {
-    cTAppDecTop.destroy();
-    returnCode = EXIT_FAILURE;
-    return returnCode;
-  }
+    // parse configuration
+    if(!cTAppDecTop.parseCfg( argc, argv ))
+    {
+      cTAppDecTop.destroy();
+      returnCode = EXIT_FAILURE;
+      return returnCode;
+    }
+#if NH_MV
+    numDecodings = cTAppDecTop.getNumDecodings(); 
+#endif
 
-  // starting time
+    // starting time    
+#if !NH_MV
   Double dResult;
-  clock_t lBefore = clock();
+#endif
+    clock_t lBefore = clock();
 
-  // call decoding function
-  cTAppDecTop.decode();
+    // call decoding function
+#if NH_MV
+    cTAppDecTop.decode( curDecoding );
+#else
+    cTAppDecTop.decode();
+#endif
 
-  if (cTAppDecTop.getNumberOfChecksumErrorsDetected() != 0)
-  {
-    printf("\n\n***ERROR*** A decoding mismatch occured: signalled md5sum does not match\n");
-    returnCode = EXIT_FAILURE;
-  }
+    if (cTAppDecTop.getNumberOfChecksumErrorsDetected() != 0)
+    {
+      printf("\n\n***ERROR*** A decoding mismatch occured: signalled md5sum does not match\n");
+      returnCode = EXIT_FAILURE;
+    }
 
-  // ending time
+    // ending time
+#if NH_MV
+    dResult += (double)(clock()-lBefore) / CLOCKS_PER_SEC;
+#else
   dResult = (Double)(clock()-lBefore) / CLOCKS_PER_SEC;
   printf("\n Total Time: %12.3f sec.\n", dResult);
+#endif
 
-  // destroy application decoder class
-  cTAppDecTop.destroy();
+    // destroy application decoder class
+    cTAppDecTop.destroy();
+#if NH_MV
+    curDecoding++; 
+  } 
+  while ( curDecoding < numDecodings );
 
+  printf("\n Total Time: %12.3f sec.\n", dResult);
+#endif
   return returnCode;
 }
